Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Friends | List of all members
wglGraphicsPipe Class Reference

This graphics pipe represents the interface for creating OpenGL graphics windows on the various Windows OSes. More...

`#include "wglGraphicsPipe.h"`

Inheritance diagram for wglGraphicsPipe:

## Public Member Functions
virtual TypeHandle | force_init_type ()
virtual std::string | get_interface_name () const
| Returns the name of the rendering interface associated with this GraphicsPipe.
virtual TypeHandle | get_type () const
Public Member Functions inherited from WinGraphicsPipe
virtual void | lookup_cpu_data ()
| Looks up the detailed CPU information and stores it in _display_information, if supported by the OS.
Public Member Functions inherited from GraphicsPipe
GraphicsDevice * | get_device () const
| Returns a pointer to device object.
int | get_display_height () const
DisplayInformation * | get_display_information ()
int | get_display_width () const
PN_stdfloat | get_display_zoom () const
virtual PreferredWindowThread | get_preferred_window_thread () const
| Returns an indication of the thread in which this GraphicsPipe requires its window processing to be performed: typically either the app thread (e.g.
int | get_supported_types () const
| Returns the mask of bits that represents the kinds of GraphicsOutput objects this pipe might be able to successfully create.
bool | is_valid () const
| Returns false if this pipe is known to be invalid, meaning that an attempt to create a GraphicsWindow with the pipe will certainly fail.
virtual | PT (GraphicsDevice) make_device(void *scrn
bool | supports_type (int flags) const
| A convenience function to ask if a particular type or types of GraphicsObjects are supported.
Public Member Functions inherited from TypedReferenceCount
| TypedReferenceCount (const TypedReferenceCount &copy)
void | operator= (const TypedReferenceCount &copy)
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (GraphicsPipe) pipe_constructor()
Static Public Member Functions inherited from WinGraphicsPipe
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from GraphicsPipe
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Friends
class | wglGraphicsBuffer
class | wglGraphicsStateGuardian
class | wglGraphicsWindow

## Additional Inherited Members
Public Types inherited from GraphicsPipe
enum | BufferCreationFlags { BF_refuse_parasite = 0x0001 , BF_require_parasite = 0x0002 , BF_refuse_window = 0x0004 , BF_require_window = 0x0008 , BF_require_callback_window = 0x0010 , BF_can_bind_color = 0x0040 , BF_can_bind_every = 0x0080 , BF_resizeable = 0x0100 , BF_size_track_host = 0x0200 , BF_rtt_cumulative = 0x0400 , BF_fb_props_optional = 0x0800 , BF_size_square = 0x1000 , BF_size_power_2 = 0x2000 , BF_can_bind_layered = 0x4000 }
enum | OutputTypes { OT_window = 0x0001 , OT_fullscreen_window = 0x0002 , OT_buffer = 0x0004 , OT_texture_buffer = 0x0008 }
enum | PreferredWindowThread { PWT_app , PWT_draw }
Public Attributes inherited from GraphicsPipe
| get_display_height
| Returns the height of the entire display, if it is known.
| get_display_information
| Gets the pipe's DisplayInformation.
| get_display_width
| Returns the width of the entire display, if it is known.
| get_display_zoom
| Returns the display zoom factor configured in the operating system.
| get_interface_name
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Detailed Description

This graphics pipe represents the interface for creating OpenGL graphics windows on the various Windows OSes.

Definition at line 26 of file wglGraphicsPipe.h.

## Constructor & Destructor Documentation

## ◆ wglGraphicsPipe()

wglGraphicsPipe::wglGraphicsPipe | ( |  | ) |

Definition at line 30 of file wglGraphicsPipe.cxx.

## ◆ ~wglGraphicsPipe()

wglGraphicsPipe::~wglGraphicsPipe | ( |  | ) |
| virtual

Definition at line 38 of file wglGraphicsPipe.cxx.

## Member Function Documentation

## ◆ force_init_type()

virtual TypeHandle wglGraphicsPipe::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from WinGraphicsPipe.

Definition at line 68 of file wglGraphicsPipe.h.

## ◆ get_class_type()

static TypeHandle wglGraphicsPipe::get_class_type | ( |  | ) |
| inline static

Definition at line 57 of file wglGraphicsPipe.h.

## ◆ get_interface_name()

std::string wglGraphicsPipe::get_interface_name | ( |  | ) | const
| virtual

Returns the name of the rendering interface associated with this GraphicsPipe.

This is used to present to the user to allow him/her to choose between several possible GraphicsPipes available on a particular platform, so the name should be meaningful and unique for a given platform.

Implements GraphicsPipe.

Definition at line 74 of file wglGraphicsPipe.cxx.

## ◆ get_type()

virtual TypeHandle wglGraphicsPipe::get_type | ( |  | ) | const
| inline virtual

Reimplemented from WinGraphicsPipe.

Definition at line 65 of file wglGraphicsPipe.h.

## ◆ init_type()

static void wglGraphicsPipe::init_type | ( |  | ) |
| inline static

Definition at line 60 of file wglGraphicsPipe.h.

## Friends And Related Symbol Documentation

## ◆ wglGraphicsBuffer

friend class wglGraphicsBuffer
| friend

Definition at line 73 of file wglGraphicsPipe.h.

## ◆ wglGraphicsStateGuardian

friend class wglGraphicsStateGuardian
| friend

Definition at line 75 of file wglGraphicsPipe.h.

## ◆ wglGraphicsWindow

friend class wglGraphicsWindow
| friend

Definition at line 74 of file wglGraphicsPipe.h.

The documentation for this class was generated from the following files:

- panda/src/wgldisplay/wglGraphicsPipe.h
- panda/src/wgldisplay/wglGraphicsPipe.cxx